/* This file was generated by SableCC (http://www.sablecc.org/). */

package de.be4.classicalb.core.preparser.lexer;

import java.io.*;
import java.util.*;
import de.be4.classicalb.core.preparser.node.*;
import de.hhu.stups.sablecc.patch.*;
import java.util.concurrent.LinkedBlockingQueue;

@SuppressWarnings({"unused"}) 
public class Lexer implements ITokenListContainer
{
    protected Token token;
    protected State state = State.NORMAL;

    private PushbackReader in;
    private int line;
    private int pos;
    private boolean cr;
    private boolean eof;
    private final StringBuffer text = new StringBuffer();
    
	private List<IToken> tokenList;
    private final Queue<IToken> nextList = new LinkedBlockingQueue<IToken>();

	private IToken tok;

    public Queue<IToken> getNextList() {
        return nextList;
    }

	public List<IToken> getTokenList() {
		return tokenList;
	}
	
	private void setToken(Token t) {
	  tok = t;
   	  token = t;	
	}
	
	
	public void setTokenList(final List<IToken> list) {
		tokenList = list;
	}

     
    protected void filter() throws LexerException, IOException
    {
        // Do nothing
    }

    protected void filterWrap() throws LexerException, IOException
    {
       filter();
       if (token != null) {
	          getTokenList().add(token); 
              nextList.add(token);
	   }
    }


    public Lexer(  PushbackReader in)
    {
        this.in = in;
    	setTokenList(new ArrayList<IToken>());
    }
    
    public Token peek() throws LexerException, IOException
    {
        while(this.token == null)
        {
            this.setToken(getToken());
            filterWrap();
        }

        return (Token) nextList.peek();
    }

    public Token next() throws LexerException, IOException
    {
        while(this.token == null)
        {
            this.setToken(getToken());
            filterWrap();
        }

        Token result = (Token) nextList.poll();
        this.setToken(null);
        return result;
    }

    protected Token getToken() throws IOException, LexerException
    {
        int dfa_state = 0;

        int start_pos = this.pos;
        int start_line = this.line;

        int accept_state = -1;
        int accept_token = -1;
        int accept_length = -1;
        int accept_pos = -1;
        int accept_line = -1;

          int[][][] gotoTable = Lexer.gotoTable[this.state.id()];
          int[] accept = Lexer.accept[this.state.id()];
        this.text.setLength(0);

        while(true)
        {
            int c = getChar();

            if(c != -1)
            {
                switch(c)
                {
                case 10:
                    if(this.cr)
                    {
                        this.cr = false;
                    }
                    else
                    {
                        this.line++;
                        this.pos = 0;
                    }
                    break;
                case 13:
                    this.line++;
                    this.pos = 0;
                    this.cr = true;
                    break;
                default:
                    this.pos++;
                    this.cr = false;
                    break;
                }

                this.text.append((char) c);

                do
                {
                    int oldState = (dfa_state < -1) ? (-2 -dfa_state) : dfa_state;

                    dfa_state = -1;

                    int[][] tmp1 =  gotoTable[oldState];
                    int low = 0;
                    int high = tmp1.length - 1;

                    while(low <= high)
                    {
                        int middle = (low + high) / 2;
                        int[] tmp2 = tmp1[middle];

                        if(c < tmp2[0])
                        {
                            high = middle - 1;
                        }
                        else if(c > tmp2[1])
                        {
                            low = middle + 1;
                        }
                        else
                        {
                            dfa_state = tmp2[2];
                            break;
                        }
                    }
                }while(dfa_state < -1);
            }
            else
            {
                dfa_state = -1;
            }

            if(dfa_state >= 0)
            {
                if(accept[dfa_state] != -1)
                {
                    accept_state = dfa_state;
                    accept_token = accept[dfa_state];
                    accept_length = this.text.length();
                    accept_pos = this.pos;
                    accept_line = this.line;
                }
            }
            else
            {
                if(accept_state != -1)
                {
                    switch(accept_token)
                    {
                    case 0:
                        {
                              Token token = new0(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.DEFINITIONS; break;
                                case 2: state = State.DEFINITIONS_RHS; break;
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 1:
                        {
                              Token token = new1(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 5: state = State.COMMENT; break;
                            }
                            return token;
                        }
                    case 2:
                        {
                              Token token = new2(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 5: state = State.COMMENT; break;
                            }
                            return token;
                        }
                    case 3:
                        {
                              Token token = new3(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.DEFINITIONS; break;
                                case 2: state = State.DEFINITIONS_RHS; break;
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 4:
                        {
                              Token token = new4(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.DEFINITIONS; break;
                            }
                            return token;
                        }
                    case 5:
                        {
                              Token token = new5(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                                case 2: state = State.DEFINITIONS_RHS; break;
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 6:
                        {
                              Token token = new6(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 7:
                        {
                              Token token = new7(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 8:
                        {
                              Token token = new8(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NO_DEFINITIONS; break;
                            }
                            return token;
                        }
                    case 9:
                        {
                              Token token = new9(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 4: state = State.NO_DEFINITIONS; break;
                            }
                            return token;
                        }
                    case 10:
                        {
                              Token token = new10(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.DEFINITIONS; break;
                            }
                            return token;
                        }
                    case 11:
                        {
                              Token token = new11(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.DEFINITIONS; break;
                                case 2: state = State.DEFINITIONS_RHS; break;
                            }
                            return token;
                        }
                    case 12:
                        {
                              Token token = new12(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.DEFINITIONS; break;
                                case 2: state = State.DEFINITIONS_RHS; break;
                            }
                            return token;
                        }
                    case 13:
                        {
                              Token token = new13(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.DEFINITIONS; break;
                                case 2: state = State.DEFINITIONS_RHS; break;
                            }
                            return token;
                        }
                    case 14:
                        {
                              Token token = new14(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.DEFINITIONS; break;
                            }
                            return token;
                        }
                    case 15:
                        {
                              Token token = new15(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.DEFINITIONS_RHS; break;
                            }
                            return token;
                        }
                    case 16:
                        {
                              Token token = new16(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 2: state = State.DEFINITIONS_RHS; break;
                            }
                            return token;
                        }
                    case 17:
                        {
                              Token token = new17(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 2: state = State.DEFINITIONS_RHS; break;
                            }
                            return token;
                        }
                    case 18:
                        {
                              Token token = new18(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 2: state = State.DEFINITIONS_RHS; break;
                            }
                            return token;
                        }
                    case 19:
                        {
                              Token token = new19(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 2: state = State.DEFINITIONS_RHS; break;
                            }
                            return token;
                        }
                    case 20:
                        {
                              Token token = new20(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.DEFINITIONS; break;
                                case 2: state = State.DEFINITIONS_RHS; break;
                            }
                            return token;
                        }
                    case 21:
                        {
                              Token token = new21(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.DEFINITION_FILE; break;
                                case 3: state = State.DEFINITIONS; break;
                            }
                            return token;
                        }
                    case 22:
                        {
                              Token token = new22(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 3: state = State.DEFINITION_FILE; break;
                            }
                            return token;
                        }
                    case 23:
                        {
                              Token token = new23(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 24:
                        {
                              Token token = new24(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    }
                }
                else
                {
                    if(this.text.length() > 0)
                    {
                        throw new LexerException(
                            "[" + (start_line + 1) + "," + (start_pos + 1) + "]" +
                            " Unknown token: " + this.text);
                    }

                      EOF token = new EOF(
                        start_line + 1,
                        start_pos + 1);
                    return token;
                }
            }
        }
    }

    Token new0(  String text,   int line,   int pos) { return new TComment(text, line, pos); }
    Token new1(  String text,   int line,   int pos) { return new TCommentEnd(text, line, pos); }
    Token new2(  String text,   int line,   int pos) { return new TCommentContent(text, line, pos); }
    Token new3(  String text,   int line,   int pos) { return new TLineComment(text, line, pos); }
    Token new4(  int line,   int pos) { return new TDefinitions(line, pos); }
    Token new5(  String text,   int line,   int pos) { return new TOtherClauseBegin(text, line, pos); }
    Token new6(  String text,   int line,   int pos) { return new TEndMachine(text, line, pos); }
    Token new7(  int line,   int pos) { return new TKwDefinitions(line, pos); }
    Token new8(  String text,   int line,   int pos) { return new TKwPrefix(text, line, pos); }
    Token new9(  String text,   int line,   int pos) { return new TNoDefSomething(text, line, pos); }
    Token new10(  String text,   int line,   int pos) { return new TIdentifierLiteral(text, line, pos); }
    Token new11(  int line,   int pos) { return new TLeftPar(line, pos); }
    Token new12(  int line,   int pos) { return new TRightPar(line, pos); }
    Token new13(  String text,   int line,   int pos) { return new TSlash(text, line, pos); }
    Token new14(  int line,   int pos) { return new TComma(line, pos); }
    Token new15(  int line,   int pos) { return new TBeginDefBody(line, pos); }
    Token new16(  String text,   int line,   int pos) { return new TRhsBody(text, line, pos); }
    Token new17(  String text,   int line,   int pos) { return new TBeginNesting(text, line, pos); }
    Token new18(  String text,   int line,   int pos) { return new TEndNesting(text, line, pos); }
    Token new19(  String text,   int line,   int pos) { return new TRhsIdentifier(text, line, pos); }
    Token new20(  String text,   int line,   int pos) { return new TSemicolon(text, line, pos); }
    Token new21(  String text,   int line,   int pos) { return new TDoubleQuotation(text, line, pos); }
    Token new22(  String text,   int line,   int pos) { return new TFilename(text, line, pos); }
    Token new23(  String text,   int line,   int pos) { return new TSomething(text, line, pos); }
    Token new24(  String text,   int line,   int pos) { return new TWhiteSpace(text, line, pos); }

    private int getChar() throws IOException
    {
        if(this.eof)
        {
            return -1;
        }

        int result = this.in.read();

        if(result == -1)
        {
            this.eof = true;
        }

        return result;
    }

    private void pushBack(int acceptLength) throws IOException
    {
        int length = this.text.length();
        for(int i = length - 1; i >= acceptLength; i--)
        {
            this.eof = false;

            this.in.unread(this.text.charAt(i));
        }
    }

    protected void unread(  Token token) throws IOException
    {
          String text = token.getText();
        int length = text.length();

        for(int i = length - 1; i >= 0; i--)
        {
            this.eof = false;

            this.in.unread(text.charAt(i));
        }

        this.pos = token.getPos() - 1;
        this.line = token.getLine() - 1;
    }

    private String getText(int acceptLength)
    {
        StringBuffer s = new StringBuffer(acceptLength);
        for(int i = 0; i < acceptLength; i++)
        {
            s.append(this.text.charAt(i));
        }

        return s.toString();
    }

    private static int[][][][] gotoTable;
/*  {
        { // NORMAL
            {{0, 32, 1}, {33, 33, 2}, {34, 34, 3}, {35, 35, 4}, {36, 46, 2}, {47, 47, 5}, {48, 64, 2}, {65, 65, 6}, {66, 66, 7}, {67, 67, 8}, {68, 68, 9}, {69, 69, 10}, {70, 72, 7}, {73, 73, 11}, {74, 75, 7}, {76, 76, 12}, {77, 77, 13}, {78, 78, 7}, {79, 79, 14}, {80, 80, 15}, {81, 81, 7}, {82, 82, 16}, {83, 83, 17}, {84, 84, 7}, {85, 85, 18}, {86, 86, 19}, {87, 90, 7}, {91, 96, 2}, {97, 122, 20}, {123, 126, 2}, {127, 160, 1}, {161, 8205, 2}, {8206, 8207, 1}, {8208, 8231, 2}, {8232, 8233, 1}, {8234, 65535, 2}, },
            {{0, 32, 21}, {127, 160, 21}, {8206, 8207, 21}, {8232, 8233, 21}, },
            {},
            {{0, 33, 22}, {34, 34, 23}, {35, 91, 22}, {92, 92, 24}, {93, 65535, 22}, },
            {{68, 68, 25}, {69, 69, 26}, {80, 80, 27}, {83, 83, 28}, },
            {{42, 42, 29}, {47, 47, 30}, },
            {{48, 57, 31}, {65, 65, 32}, {66, 66, 33}, {67, 82, 32}, {83, 83, 34}, {84, 90, 32}, {95, 95, 35}, {97, 122, 36}, },
            {{48, 57, 31}, {65, 90, 32}, {95, 122, -8}, },
            {{48, 57, 31}, {65, 78, 32}, {79, 79, 37}, {80, 90, 32}, {95, 122, -8}, },
            {{48, 57, 31}, {65, 68, 32}, {69, 69, 38}, {70, 90, 32}, {95, 122, -8}, },
            {{48, 57, 31}, {65, 77, 32}, {78, 78, 39}, {79, 85, 32}, {86, 86, 40}, {87, 87, 32}, {88, 88, 41}, {89, 90, 32}, {95, 122, -8}, },
            {{48, 57, 31}, {65, 76, 32}, {77, 77, 42}, {78, 78, 43}, {79, 90, 32}, {95, 122, -8}, },
            {{48, 78, -10}, {79, 79, 44}, {80, 122, -10}, },
            {{48, 57, 31}, {65, 65, 45}, {66, 78, 32}, {79, 79, 46}, {80, 122, -10}, },
            {{48, 57, 31}, {65, 79, 32}, {80, 80, 47}, {81, 90, 32}, {95, 122, -8}, },
            {{48, 57, 31}, {65, 81, 32}, {82, 82, 48}, {83, 90, 32}, {95, 122, -8}, },
            {{48, 68, -11}, {69, 69, 49}, {70, 84, 32}, {85, 85, 50}, {86, 90, 32}, {95, 122, -8}, },
            {{48, 68, -11}, {69, 69, 51}, {70, 88, 32}, {89, 89, 52}, {90, 90, 32}, {95, 122, -8}, },
            {{48, 57, 31}, {65, 82, 32}, {83, 83, 53}, {84, 122, -8}, },
            {{48, 57, 31}, {65, 65, 54}, {66, 90, 32}, {95, 122, -8}, },
            {{48, 122, -9}, },
            {{0, 8233, -3}, },
            {{0, 65535, -5}, },
            {},
            {{0, 33, 22}, {34, 34, 55}, {35, 65535, -5}, },
            {{69, 69, 56}, },
            {{88, 88, 57}, },
            {{82, 82, 58}, },
            {{85, 85, 59}, },
            {},
            {{0, 9, 60}, {10, 10, 61}, {11, 12, 60}, {13, 13, 61}, {14, 65535, 60}, },
            {{48, 122, -9}, },
            {{48, 122, -9}, },
            {{48, 82, -20}, {83, 83, 62}, {84, 122, -8}, },
            {{48, 82, -20}, {83, 83, 63}, {84, 122, -8}, },
            {{48, 122, -9}, },
            {{48, 122, -9}, },
            {{48, 77, -12}, {78, 78, 64}, {79, 122, -13}, },
            {{48, 57, 31}, {65, 69, 32}, {70, 70, 65}, {71, 90, 32}, {95, 122, -8}, },
            {{48, 57, 31}, {65, 67, 32}, {68, 68, 66}, {69, 90, 32}, {95, 122, -8}, },
            {{48, 68, -11}, {69, 69, 67}, {70, 122, -11}, },
            {{48, 57, 31}, {65, 83, 32}, {84, 84, 68}, {85, 90, 32}, {95, 122, -8}, },
            {{48, 79, -16}, {80, 80, 69}, {81, 122, -16}, },
            {{48, 57, 31}, {65, 66, 32}, {67, 67, 70}, {68, 72, 32}, {73, 73, 71}, {74, 85, 32}, {86, 86, 72}, {87, 90, 32}, {95, 122, -8}, },
            {{48, 66, -45}, {67, 67, 73}, {68, 90, 32}, {95, 122, -8}, },
            {{48, 66, -45}, {67, 67, 74}, {68, 122, -46}, },
            {{48, 67, -41}, {68, 68, 75}, {69, 122, -41}, },
            {{48, 68, -11}, {69, 69, 76}, {70, 122, -11}, },
            {{48, 78, -10}, {79, 79, 77}, {80, 122, -10}, },
            {{48, 69, -40}, {70, 70, 78}, {71, 122, -40}, },
            {{48, 57, 31}, {65, 75, 32}, {76, 76, 79}, {77, 90, 32}, {95, 122, -8}, },
            {{48, 68, -11}, {69, 69, 80}, {70, 83, 32}, {84, 84, 81}, {85, 122, -43}, },
            {{48, 82, -20}, {83, 83, 82}, {84, 122, -8}, },
            {{48, 68, -11}, {69, 69, 83}, {70, 122, -11}, },
            {{48, 75, -52}, {76, 76, 84}, {77, 81, 32}, {82, 82, 85}, {83, 122, -17}, },
            {{0, 65535, -5}, },
            {{70, 70, 86}, },
            {{80, 80, 87}, },
            {{69, 69, 88}, },
            {{66, 66, 89}, },
            {{0, 65535, -32}, },
            {},
            {{48, 83, -43}, {84, 84, 90}, {85, 122, -43}, },
            {{48, 68, -11}, {69, 69, 91}, {70, 122, -11}, },
            {{48, 66, -45}, {67, 67, 92}, {68, 82, 32}, {83, 83, 93}, {84, 122, -8}, },
            {{48, 57, 31}, {65, 72, 32}, {73, 73, 94}, {74, 90, 32}, {95, 122, -8}, },
            {{48, 122, -9}, },
            {{48, 77, -12}, {78, 78, 95}, {79, 122, -13}, },
            {{48, 68, -11}, {69, 69, 96}, {70, 122, -11}, },
            {{48, 75, -52}, {76, 76, 97}, {77, 78, 32}, {79, 79, 98}, {80, 122, -10}, },
            {{48, 75, -52}, {76, 76, 99}, {77, 122, -52}, },
            {{48, 83, -43}, {84, 84, 100}, {85, 122, -43}, },
            {{48, 57, 31}, {65, 65, 101}, {66, 122, -21}, },
            {{48, 57, 31}, {65, 65, 102}, {66, 122, -21}, },
            {{48, 57, 31}, {65, 71, 32}, {72, 72, 103}, {73, 90, 32}, {95, 122, -8}, },
            {{48, 68, -11}, {69, 69, 104}, {70, 122, -11}, },
            {{48, 81, -17}, {82, 82, 105}, {83, 122, -17}, },
            {{48, 76, -13}, {77, 77, 106}, {78, 79, 32}, {80, 80, 107}, {81, 122, -16}, },
            {{48, 72, -67}, {73, 73, 108}, {74, 122, -67}, },
            {{48, 68, -11}, {69, 69, 109}, {70, 122, -11}, },
            {{48, 82, -20}, {83, 83, 110}, {84, 122, -8}, },
            {{48, 82, -20}, {83, 83, 111}, {84, 122, -8}, },
            {{48, 83, -43}, {84, 84, 112}, {85, 122, -43}, },
            {{48, 82, -20}, {83, 83, 113}, {84, 122, -8}, },
            {{48, 57, 31}, {65, 84, 32}, {85, 85, 114}, {86, 122, -18}, },
            {{48, 72, -67}, {73, 73, 115}, {74, 122, -67}, },
            {{73, 73, 116}, },
            {{82, 82, 117}, },
            {{68, 68, 118}, },
            {{83, 83, 119}, },
            {{48, 81, -17}, {82, 82, 120}, {83, 122, -17}, },
            {{48, 81, -17}, {82, 82, 121}, {83, 122, -17}, },
            {{48, 81, -17}, {82, 82, 122}, {83, 122, -17}, },
            {{48, 83, -43}, {84, 84, 123}, {85, 122, -43}, },
            {{48, 77, -12}, {78, 78, 124}, {79, 122, -13}, },
            {{48, 83, -43}, {84, 84, 125}, {85, 122, -43}, },
            {{48, 77, -12}, {78, 78, 126}, {79, 122, -13}, },
            {{48, 68, -11}, {69, 69, 127}, {70, 122, -11}, },
            {{48, 81, -17}, {82, 82, 128}, {83, 122, -17}, },
            {{48, 84, -86}, {85, 85, 129}, {86, 122, -18}, },
            {{48, 72, -67}, {73, 73, 130}, {74, 122, -67}, },
            {{48, 81, -17}, {82, 82, 131}, {83, 122, -17}, },
            {{48, 75, -52}, {76, 76, 132}, {77, 122, -52}, },
            {{48, 72, -67}, {73, 73, 133}, {74, 122, -67}, },
            {{48, 75, -52}, {76, 76, 134}, {77, 122, -52}, },
            {{48, 57, 31}, {65, 65, 135}, {66, 122, -21}, },
            {{48, 78, -10}, {79, 79, 136}, {80, 122, -10}, },
            {{48, 68, -11}, {69, 69, 137}, {70, 122, -11}, },
            {{48, 77, -12}, {78, 78, 138}, {79, 122, -13}, },
            {{48, 82, -20}, {83, 83, 139}, {84, 122, -8}, },
            {{48, 122, -9}, },
            {{48, 122, -9}, },
            {{48, 68, -11}, {69, 69, 140}, {70, 122, -11}, },
            {{48, 122, -9}, },
            {{48, 68, -11}, {69, 69, 141}, {70, 122, -11}, },
            {{48, 57, 31}, {65, 65, 142}, {66, 122, -21}, },
            {{78, 78, 143}, },
            {{69, 69, 144}, },
            {{73, 73, 145}, },
            {{84, 84, 146}, },
            {{48, 57, 31}, {65, 65, 147}, {66, 122, -21}, },
            {{48, 83, -43}, {84, 84, 148}, {85, 122, -43}, },
            {{48, 68, -11}, {69, 69, 149}, {70, 122, -11}, },
            {{48, 57, 31}, {65, 65, 150}, {66, 81, 32}, {82, 82, 151}, {83, 122, -17}, },
            {{48, 72, -67}, {73, 73, 152}, {74, 122, -67}, },
            {{48, 82, -20}, {83, 83, 153}, {84, 122, -8}, },
            {{48, 67, -41}, {68, 68, 154}, {69, 122, -41}, },
            {{48, 76, -13}, {77, 77, 155}, {78, 90, 32}, {95, 122, -8}, },
            {{48, 83, -43}, {84, 84, 156}, {85, 122, -43}, },
            {{48, 67, -41}, {68, 68, 157}, {69, 122, -41}, },
            {{48, 57, 31}, {65, 65, 158}, {66, 122, -21}, },
            {{48, 72, -67}, {73, 73, 159}, {74, 122, -67}, },
            {{48, 90, -9}, {95, 95, 160}, {97, 122, 36}, },
            {{48, 77, -12}, {78, 78, 161}, {79, 122, -13}, },
            {{48, 122, -9}, },
            {{48, 83, -43}, {84, 84, 162}, {85, 122, -43}, },
            {{48, 83, -43}, {84, 84, 163}, {85, 122, -43}, },
            {{48, 81, -17}, {82, 82, 164}, {83, 122, -17}, },
            {{48, 68, -11}, {69, 69, 165}, {70, 122, -11}, },
            {{48, 90, -9}, {95, 95, 166}, {97, 122, 36}, },
            {{48, 76, -13}, {77, 77, 167}, {78, 122, -129}, },
            {{48, 82, -20}, {83, 83, 168}, {84, 122, -8}, },
            {{48, 65, -8}, {66, 66, 169}, {67, 90, 32}, {95, 122, -8}, },
            {{73, 73, 170}, },
            {{83, 83, 171}, },
            {{67, 67, 172}, },
            {{73, 73, 173}, },
            {{48, 66, -45}, {67, 67, 174}, {68, 122, -46}, },
            {{48, 72, -67}, {73, 73, 175}, {74, 122, -67}, },
            {{48, 83, -43}, {84, 84, 176}, {85, 122, -43}, },
            {{48, 77, -12}, {78, 78, 177}, {79, 122, -13}, },
            {{48, 57, 31}, {65, 65, 178}, {66, 122, -21}, },
            {{48, 83, -43}, {84, 84, 179}, {85, 122, -43}, },
            {{48, 122, -9}, },
            {{48, 82, -20}, {83, 83, 180}, {84, 122, -8}, },
            {{48, 68, -11}, {69, 69, 181}, {70, 122, -11}, },
            {{48, 82, -20}, {83, 83, 182}, {84, 122, -8}, },
            {{48, 68, -11}, {69, 69, 183}, {70, 122, -11}, },
            {{48, 75, -52}, {76, 76, 184}, {77, 122, -52}, },
            {{48, 57, 31}, {65, 65, 185}, {66, 122, -21}, },
            {{48, 78, -10}, {79, 79, 186}, {80, 122, -10}, },
            {{48, 68, -11}, {69, 69, 187}, {70, 122, -11}, },
            {{48, 72, -67}, {73, 73, 188}, {74, 122, -67}, },
            {{48, 68, -11}, {69, 69, 189}, {70, 122, -11}, },
            {{48, 83, -43}, {84, 84, 190}, {85, 122, -43}, },
            {{48, 76, -13}, {77, 77, 191}, {78, 82, 32}, {83, 83, 192}, {84, 122, -8}, },
            {{48, 76, -13}, {77, 77, 193}, {78, 122, -129}, },
            {{48, 122, -9}, },
            {{48, 122, -9}, },
            {{48, 75, -52}, {76, 76, 194}, {77, 122, -52}, },
            {{84, 84, 195}, },
            {{83, 83, 196}, },
            {{65, 65, 197}, },
            {{84, 84, 198}, },
            {{48, 83, -43}, {84, 84, 199}, {85, 122, -43}, },
            {{48, 78, -10}, {79, 79, 200}, {80, 122, -10}, },
            {{48, 68, -11}, {69, 69, 201}, {70, 122, -11}, },
            {{48, 83, -43}, {84, 84, 202}, {85, 122, -43}, },
            {{48, 72, -67}, {73, 73, 203}, {74, 122, -67}, },
            {{48, 72, -67}, {73, 73, 204}, {74, 122, -67}, },
            {{48, 122, -9}, },
            {{48, 77, -12}, {78, 78, 205}, {79, 122, -13}, },
            {{48, 122, -9}, },
            {{48, 82, -20}, {83, 83, 206}, {84, 122, -8}, },
            {{48, 72, -67}, {73, 73, 207}, {74, 122, -67}, },
            {{48, 77, -12}, {78, 78, 208}, {79, 122, -13}, },
            {{48, 79, -16}, {80, 80, 209}, {81, 122, -16}, },
            {{48, 122, -9}, },
            {{48, 78, -10}, {79, 79, 210}, {80, 122, -10}, },
            {{48, 82, -20}, {83, 83, 211}, {84, 122, -8}, },
            {{48, 72, -67}, {73, 73, 212}, {74, 122, -67}, },
            {{48, 68, -11}, {69, 69, 213}, {70, 122, -11}, },
            {{48, 122, -9}, },
            {{48, 57, 31}, {65, 65, 214}, {66, 122, -21}, },
            {{48, 68, -11}, {69, 69, 215}, {70, 122, -11}, },
            {{73, 73, 216}, },
            {{73, 73, 217}, },
            {{84, 84, 218}, },
            {{85, 85, 219}, },
            {{48, 90, -9}, {95, 95, 220}, {97, 122, 36}, },
            {{48, 77, -12}, {78, 78, 221}, {79, 122, -13}, },
            {{48, 90, -9}, {95, 95, 222}, {97, 122, 36}, },
            {{48, 82, -20}, {83, 83, 223}, {84, 122, -8}, },
            {{48, 77, -12}, {78, 78, 224}, {79, 122, -13}, },
            {{48, 78, -10}, {79, 79, 225}, {80, 122, -10}, },
            {{48, 83, -43}, {84, 84, 226}, {85, 122, -43}, },
            {{48, 122, -9}, },
            {{48, 82, -20}, {83, 83, 227}, {84, 89, 32}, {90, 90, 228}, {95, 122, -8}, },
            {{48, 83, -43}, {84, 84, 229}, {85, 122, -43}, },
            {{48, 68, -11}, {69, 69, 230}, {70, 122, -11}, },
            {{48, 77, -12}, {78, 78, 231}, {79, 122, -13}, },
            {{48, 122, -9}, },
            {{48, 68, -11}, {69, 69, 232}, {70, 122, -11}, },
            {{48, 77, -12}, {78, 78, 233}, {79, 122, -13}, },
            {{48, 66, -45}, {67, 67, 234}, {68, 122, -46}, },
            {{48, 82, -20}, {83, 83, 235}, {84, 122, -8}, },
            {{79, 79, 236}, },
            {{79, 79, 237}, },
            {{69, 69, 238}, },
            {{84, 84, 239}, },
            {{48, 66, -45}, {67, 67, 240}, {68, 85, 32}, {86, 86, 241}, {87, 122, -45}, },
            {{48, 82, -20}, {83, 83, 242}, {84, 122, -8}, },
            {{48, 66, -45}, {67, 67, 243}, {68, 85, 32}, {86, 86, 244}, {87, 122, -45}, },
            {{48, 122, -9}, },
            {{48, 83, -43}, {84, 84, 245}, {85, 122, -43}, },
            {{48, 77, -12}, {78, 78, 246}, {79, 122, -13}, },
            {{48, 57, 31}, {65, 65, 247}, {66, 122, -21}, },
            {{48, 57, 31}, {65, 65, 248}, {66, 122, -21}, },
            {{48, 57, 31}, {65, 65, 249}, {66, 122, -21}, },
            {{48, 122, -9}, },
            {{48, 81, -17}, {82, 82, 250}, {83, 122, -17}, },
            {{48, 82, -20}, {83, 83, 251}, {84, 122, -8}, },
            {{48, 82, -20}, {83, 83, 252}, {84, 122, -8}, },
            {{48, 83, -43}, {84, 84, 253}, {85, 122, -43}, },
            {{48, 71, -76}, {72, 72, 254}, {73, 122, -76}, },
            {{48, 122, -9}, },
            {{78, 78, 255}, },
            {{78, 78, 256}, },
            {},
            {{73, 73, 257}, },
            {{48, 78, -10}, {79, 79, 258}, {80, 122, -10}, },
            {{48, 57, 31}, {65, 65, 259}, {66, 122, -21}, },
            {{48, 122, -9}, },
            {{48, 78, -10}, {79, 79, 260}, {80, 122, -10}, },
            {{48, 57, 31}, {65, 65, 261}, {66, 122, -21}, },
            {{48, 82, -20}, {83, 83, 262}, {84, 122, -8}, },
            {{48, 82, -20}, {83, 83, 263}, {84, 122, -8}, },
            {{48, 83, -43}, {84, 84, 264}, {85, 122, -43}, },
            {{48, 83, -43}, {84, 84, 265}, {85, 122, -43}, },
            {{48, 83, -43}, {84, 84, 266}, {85, 122, -43}, },
            {{48, 57, 31}, {65, 65, 267}, {66, 122, -21}, },
            {{48, 122, -9}, },
            {{48, 122, -9}, },
            {{48, 122, -9}, },
            {{48, 72, -67}, {73, 73, 268}, {74, 122, -67}, },
            {{83, 83, 269}, },
            {},
            {{79, 79, 270}, },
            {{48, 77, -12}, {78, 78, 271}, {79, 122, -13}, },
            {{48, 81, -17}, {82, 82, 272}, {83, 122, -17}, },
            {{48, 77, -12}, {78, 78, 273}, {79, 122, -13}, },
            {{48, 81, -17}, {82, 82, 274}, {83, 122, -17}, },
            {{48, 122, -9}, },
            {{48, 122, -9}, },
            {{48, 72, -67}, {73, 73, 275}, {74, 122, -67}, },
            {{48, 72, -67}, {73, 73, 276}, {74, 122, -67}, },
            {{48, 72, -67}, {73, 73, 277}, {74, 122, -67}, },
            {{48, 83, -43}, {84, 84, 278}, {85, 122, -43}, },
            {{48, 77, -12}, {78, 78, 279}, {79, 122, -13}, },
            {},
            {{78, 78, 280}, },
            {{48, 82, -20}, {83, 83, 281}, {84, 122, -8}, },
            {{48, 72, -67}, {73, 73, 282}, {74, 122, -67}, },
            {{48, 82, -20}, {83, 83, 283}, {84, 122, -8}, },
            {{48, 72, -67}, {73, 73, 284}, {74, 122, -67}, },
            {{48, 78, -10}, {79, 79, 285}, {80, 122, -10}, },
            {{48, 78, -10}, {79, 79, 286}, {80, 122, -10}, },
            {{48, 78, -10}, {79, 79, 287}, {80, 122, -10}, },
            {{48, 72, -67}, {73, 73, 288}, {74, 122, -67}, },
            {{48, 68, -11}, {69, 69, 289}, {70, 122, -11}, },
            {},
            {{48, 83, -43}, {84, 84, 290}, {85, 122, -43}, },
            {{48, 57, 31}, {65, 65, 291}, {66, 122, -21}, },
            {{48, 83, -43}, {84, 84, 292}, {85, 122, -43}, },
            {{48, 57, 31}, {65, 65, 293}, {66, 122, -21}, },
            {{48, 77, -12}, {78, 78, 294}, {79, 122, -13}, },
            {{48, 77, -12}, {78, 78, 295}, {79, 122, -13}, },
            {{48, 77, -12}, {78, 78, 296}, {79, 122, -13}, },
            {{48, 78, -10}, {79, 79, 297}, {80, 122, -10}, },
            {{48, 122, -9}, },
            {{48, 57, 31}, {65, 65, 298}, {66, 122, -21}, },
            {{48, 65, -8}, {66, 66, 299}, {67, 122, -144}, },
            {{48, 57, 31}, {65, 65, 300}, {66, 122, -21}, },
            {{48, 65, -8}, {66, 66, 301}, {67, 122, -144}, },
            {{48, 122, -9}, },
            {{48, 122, -9}, },
            {{48, 122, -9}, },
            {{48, 77, -12}, {78, 78, 302}, {79, 122, -13}, },
            {{48, 77, -12}, {78, 78, 303}, {79, 122, -13}, },
            {{48, 75, -52}, {76, 76, 304}, {77, 122, -52}, },
            {{48, 77, -12}, {78, 78, 305}, {79, 122, -13}, },
            {{48, 75, -52}, {76, 76, 306}, {77, 122, -52}, },
            {{48, 82, -20}, {83, 83, 307}, {84, 122, -8}, },
            {{48, 83, -43}, {84, 84, 308}, {85, 122, -43}, },
            {{48, 68, -11}, {69, 69, 309}, {70, 122, -11}, },
            {{48, 83, -43}, {84, 84, 310}, {85, 122, -43}, },
            {{48, 68, -11}, {69, 69, 311}, {70, 122, -11}, },
            {{48, 122, -9}, },
            {{48, 82, -20}, {83, 83, 312}, {84, 122, -8}, },
            {{48, 82, -20}, {83, 83, 313}, {84, 122, -8}, },
            {{48, 82, -20}, {83, 83, 314}, {84, 122, -8}, },
            {{48, 82, -20}, {83, 83, 315}, {84, 122, -8}, },
            {{48, 122, -9}, },
            {{48, 122, -9}, },
            {{48, 122, -9}, },
            {{48, 122, -9}, },
        }
        { // DEFINITIONS
            {{0, 32, 1}, {34, 34, 2}, {40, 40, 3}, {41, 41, 4}, {44, 44, 5}, {47, 47, 6}, {59, 59, 7}, {61, 61, 8}, {65, 65, 9}, {66, 66, 10}, {67, 67, 11}, {68, 68, 10}, {69, 69, 12}, {70, 72, 10}, {73, 73, 13}, {74, 75, 10}, {76, 76, 14}, {77, 77, 15}, {78, 78, 10}, {79, 79, 16}, {80, 80, 17}, {81, 81, 10}, {82, 82, 18}, {83, 83, 19}, {84, 84, 10}, {85, 85, 20}, {86, 86, 21}, {87, 90, 10}, {97, 122, 22}, {127, 160, 1}, {8206, 8207, 1}, {8232, 8233, 1}, },
            {{0, 32, 1}, {127, 8233, -2}, },
            {},
            {},
            {},
            {},
            {{42, 42, 23}, {47, 47, 24}, },
            {},
            {{61, 61, 25}, },
            {{48, 57, 26}, {65, 65, 27}, {66, 66, 28}, {67, 82, 27}, {83, 83, 29}, {84, 90, 27}, {95, 95, 30}, {97, 122, 31}, },
            {{48, 57, 26}, {65, 90, 27}, {95, 122, -11}, },
            {{48, 57, 26}, {65, 78, 27}, {79, 79, 32}, {80, 90, 27}, {95, 122, -11}, },
            {{48, 57, 26}, {65, 77, 27}, {78, 78, 33}, {79, 85, 27}, {86, 86, 34}, {87, 87, 27}, {88, 88, 35}, {89, 90, 27}, {95, 122, -11}, },
            {{48, 57, 26}, {65, 76, 27}, {77, 77, 36}, {78, 78, 37}, {79, 90, 27}, {95, 122, -11}, },
            {{48, 78, -13}, {79, 79, 38}, {80, 122, -13}, },
            {{48, 57, 26}, {65, 65, 39}, {66, 78, 27}, {79, 79, 40}, {80, 122, -13}, },
            {{48, 57, 26}, {65, 79, 27}, {80, 80, 41}, {81, 90, 27}, {95, 122, -11}, },
            {{48, 57, 26}, {65, 81, 27}, {82, 82, 42}, {83, 90, 27}, {95, 122, -11}, },
            {{48, 57, 26}, {65, 68, 27}, {69, 69, 43}, {70, 84, 27}, {85, 85, 44}, {86, 90, 27}, {95, 122, -11}, },
            {{48, 68, -20}, {69, 69, 45}, {70, 88, 27}, {89, 89, 46}, {90, 90, 27}, {95, 122, -11}, },
            {{48, 57, 26}, {65, 82, 27}, {83, 83, 47}, {84, 122, -11}, },
            {{48, 57, 26}, {65, 65, 48}, {66, 90, 27}, {95, 122, -11}, },
            {{48, 122, -12}, },
            {},
            {{0, 9, 49}, {10, 10, 50}, {11, 12, 49}, {13, 13, 50}, {14, 65535, 49}, },
            {},
            {{48, 122, -12}, },
            {{48, 122, -12}, },
            {{48, 82, -22}, {83, 83, 51}, {84, 122, -11}, },
            {{48, 82, -22}, {83, 83, 52}, {84, 122, -11}, },
            {{48, 122, -12}, },
            {{48, 122, -12}, },
            {{48, 77, -14}, {78, 78, 53}, {79, 122, -15}, },
            {{48, 57, 26}, {65, 67, 27}, {68, 68, 54}, {69, 90, 27}, {95, 122, -11}, },
            {{48, 68, -20}, {69, 69, 55}, {70, 90, 27}, {95, 122, -11}, },
            {{48, 57, 26}, {65, 83, 27}, {84, 84, 56}, {85, 90, 27}, {95, 122, -11}, },
            {{48, 79, -18}, {80, 80, 57}, {81, 122, -18}, },
            {{48, 57, 26}, {65, 66, 27}, {67, 67, 58}, {68, 72, 27}, {73, 73, 59}, {74, 85, 27}, {86, 86, 60}, {87, 90, 27}, {95, 122, -11}, },
            {{48, 66, -39}, {67, 67, 61}, {68, 90, 27}, {95, 122, -11}, },
            {{48, 66, -39}, {67, 67, 62}, {68, 122, -40}, },
            {{48, 67, -35}, {68, 68, 63}, {69, 122, -35}, },
            {{48, 68, -20}, {69, 69, 64}, {70, 122, -36}, },
            {{48, 78, -13}, {79, 79, 65}, {80, 122, -13}, },
            {{48, 57, 26}, {65, 69, 27}, {70, 70, 66}, {71, 90, 27}, {95, 122, -11}, },
            {{48, 57, 26}, {65, 75, 27}, {76, 76, 67}, {77, 90, 27}, {95, 122, -11}, },
            {{48, 68, -20}, {69, 69, 68}, {70, 83, 27}, {84, 84, 69}, {85, 122, -37}, },
            {{48, 82, -22}, {83, 83, 70}, {84, 122, -11}, },
            {{48, 68, -20}, {69, 69, 71}, {70, 122, -36}, },
            {{48, 75, -46}, {76, 76, 72}, {77, 81, 27}, {82, 82, 73}, {83, 122, -19}, },
            {{0, 65535, -26}, },
            {},
            {{48, 83, -37}, {84, 84, 74}, {85, 122, -37}, },
            {{48, 68, -20}, {69, 69, 75}, {70, 122, -36}, },
            {{48, 66, -39}, {67, 67, 76}, {68, 82, 27}, {83, 83, 77}, {84, 122, -11}, },
            {{48, 122, -12}, },
            {{48, 77, -14}, {78, 78, 78}, {79, 122, -15}, },
            {{48, 68, -20}, {69, 69, 79}, {70, 122, -36}, },
            {{48, 75, -46}, {76, 76, 80}, {77, 78, 27}, {79, 79, 81}, {80, 122, -13}, },
            {{48, 75, -46}, {76, 76, 82}, {77, 122, -46}, },
            {{48, 83, -37}, {84, 84, 83}, {85, 122, -37}, },
            {{48, 57, 26}, {65, 65, 84}, {66, 122, -23}, },
            {{48, 57, 26}, {65, 65, 85}, {66, 122, -23}, },
            {{48, 57, 26}, {65, 71, 27}, {72, 72, 86}, {73, 90, 27}, {95, 122, -11}, },
            {{48, 68, -20}, {69, 69, 87}, {70, 122, -36}, },
            {{48, 81, -19}, {82, 82, 88}, {83, 122, -19}, },
            {{48, 76, -15}, {77, 77, 89}, {78, 79, 27}, {80, 80, 90}, {81, 122, -18}, },
            {{48, 57, 26}, {65, 72, 27}, {73, 73, 91}, {74, 90, 27}, {95, 122, -11}, },
            {{48, 68, -20}, {69, 69, 92}, {70, 122, -36}, },
            {{48, 82, -22}, {83, 83, 93}, {84, 122, -11}, },
            {{48, 82, -22}, {83, 83, 94}, {84, 122, -11}, },
            {{48, 83, -37}, {84, 84, 95}, {85, 122, -37}, },
            {{48, 82, -22}, {83, 83, 96}, {84, 122, -11}, },
            {{48, 57, 26}, {65, 84, 27}, {85, 85, 97}, {86, 122, -20}, },
            {{48, 72, -68}, {73, 73, 98}, {74, 122, -68}, },
            {{48, 81, -19}, {82, 82, 99}, {83, 122, -19}, },
            {{48, 81, -19}, {82, 82, 100}, {83, 122, -19}, },
            {{48, 81, -19}, {82, 82, 101}, {83, 122, -19}, },
            {{48, 83, -37}, {84, 84, 102}, {85, 122, -37}, },
            {{48, 83, -37}, {84, 84, 103}, {85, 122, -37}, },
            {{48, 77, -14}, {78, 78, 104}, {79, 122, -15}, },
            {{48, 68, -20}, {69, 69, 105}, {70, 122, -36}, },
            {{48, 81, -19}, {82, 82, 106}, {83, 122, -19}, },
            {{48, 84, -74}, {85, 85, 107}, {86, 122, -20}, },
            {{48, 72, -68}, {73, 73, 108}, {74, 122, -68}, },
            {{48, 81, -19}, {82, 82, 109}, {83, 122, -19}, },
            {{48, 75, -46}, {76, 76, 110}, {77, 122, -46}, },
            {{48, 72, -68}, {73, 73, 111}, {74, 122, -68}, },
            {{48, 75, -46}, {76, 76, 112}, {77, 122, -46}, },
            {{48, 57, 26}, {65, 65, 113}, {66, 122, -23}, },
            {{48, 78, -13}, {79, 79, 114}, {80, 122, -13}, },
            {{48, 68, -20}, {69, 69, 115}, {70, 122, -36}, },
            {{48, 77, -14}, {78, 78, 116}, {79, 122, -15}, },
            {{48, 82, -22}, {83, 83, 117}, {84, 122, -11}, },
            {{48, 122, -12}, },
            {{48, 122, -12}, },
            {{48, 68, -20}, {69, 69, 118}, {70, 122, -36}, },
            {{48, 122, -12}, },
            {{48, 68, -20}, {69, 69, 119}, {70, 122, -36}, },
            {{48, 57, 26}, {65, 65, 120}, {66, 122, -23}, },
            {{48, 57, 26}, {65, 65, 121}, {66, 122, -23}, },
            {{48, 83, -37}, {84, 84, 122}, {85, 122, -37}, },
            {{48, 68, -20}, {69, 69, 123}, {70, 122, -36}, },
            {{48, 57, 26}, {65, 65, 124}, {66, 81, 27}, {82, 82, 125}, {83, 122, -19}, },
            {{48, 82, -22}, {83, 83, 126}, {84, 122, -11}, },
            {{48, 67, -35}, {68, 68, 127}, {69, 122, -35}, },
            {{48, 76, -15}, {77, 77, 128}, {78, 90, 27}, {95, 122, -11}, },
            {{48, 83, -37}, {84, 84, 129}, {85, 122, -37}, },
            {{48, 67, -35}, {68, 68, 130}, {69, 122, -35}, },
            {{48, 57, 26}, {65, 65, 131}, {66, 122, -23}, },
            {{48, 72, -68}, {73, 73, 132}, {74, 122, -68}, },
            {{48, 90, -12}, {95, 95, 133}, {97, 122, 31}, },
            {{48, 77, -14}, {78, 78, 134}, {79, 122, -15}, },
            {{48, 122, -12}, },
            {{48, 83, -37}, {84, 84, 135}, {85, 122, -37}, },
            {{48, 83, -37}, {84, 84, 136}, {85, 122, -37}, },
            {{48, 81, -19}, {82, 82, 137}, {83, 122, -19}, },
            {{48, 68, -20}, {69, 69, 138}, {70, 122, -36}, },
            {{48, 90, -12}, {95, 95, 139}, {97, 122, 31}, },
            {{48, 76, -15}, {77, 77, 140}, {78, 122, -107}, },
            {{48, 82, -22}, {83, 83, 141}, {84, 122, -11}, },
            {{48, 65, -11}, {66, 66, 142}, {67, 90, 27}, {95, 122, -11}, },
            {{48, 66, -39}, {67, 67, 143}, {68, 122, -40}, },
            {{48, 72, -68}, {73, 73, 144}, {74, 122, -68}, },
            {{48, 83, -37}, {84, 84, 145}, {85, 122, -37}, },
            {{48, 77, -14}, {78, 78, 146}, {79, 122, -15}, },
            {{48, 57, 26}, {65, 65, 147}, {66, 122, -23}, },
            {{48, 122, -12}, },
            {{48, 82, -22}, {83, 83, 148}, {84, 122, -11}, },
            {{48, 68, -20}, {69, 69, 149}, {70, 122, -36}, },
            {{48, 82, -22}, {83, 83, 150}, {84, 122, -11}, },
            {{48, 68, -20}, {69, 69, 151}, {70, 122, -36}, },
            {{48, 75, -46}, {76, 76, 152}, {77, 122, -46}, },
            {{48, 57, 26}, {65, 65, 153}, {66, 122, -23}, },
            {{48, 78, -13}, {79, 79, 154}, {80, 122, -13}, },
            {{48, 68, -20}, {69, 69, 155}, {70, 122, -36}, },
            {{48, 72, -68}, {73, 73, 156}, {74, 122, -68}, },
            {{48, 68, -20}, {69, 69, 157}, {70, 122, -36}, },
            {{48, 83, -37}, {84, 84, 158}, {85, 122, -37}, },
            {{48, 76, -15}, {77, 77, 159}, {78, 82, 27}, {83, 83, 160}, {84, 122, -11}, },
            {{48, 76, -15}, {77, 77, 161}, {78, 122, -107}, },
            {{48, 122, -12}, },
            {{48, 122, -12}, },
            {{48, 75, -46}, {76, 76, 162}, {77, 122, -46}, },
            {{48, 83, -37}, {84, 84, 163}, {85, 122, -37}, },
            {{48, 78, -13}, {79, 79, 164}, {80, 122, -13}, },
            {{48, 68, -20}, {69, 69, 165}, {70, 122, -36}, },
            {{48, 83, -37}, {84, 84, 166}, {85, 122, -37}, },
            {{48, 72, -68}, {73, 73, 167}, {74, 122, -68}, },
            {{48, 122, -12}, },
            {{48, 77, -14}, {78, 78, 168}, {79, 122, -15}, },
            {{48, 122, -12}, },
            {{48, 82, -22}, {83, 83, 169}, {84, 122, -11}, },
            {{48, 72, -68}, {73, 73, 170}, {74, 122, -68}, },
            {{48, 77, -14}, {78, 78, 171}, {79, 122, -15}, },
            {{48, 79, -18}, {80, 80, 172}, {81, 122, -18}, },
            {{48, 122, -12}, },
            {{48, 78, -13}, {79, 79, 173}, {80, 122, -13}, },
            {{48, 82, -22}, {83, 83, 174}, {84, 122, -11}, },
            {{48, 72, -68}, {73, 73, 175}, {74, 122, -68}, },
            {{48, 68, -20}, {69, 69, 176}, {70, 122, -36}, },
            {{48, 122, -12}, },
            {{48, 57, 26}, {65, 65, 177}, {66, 122, -23}, },
            {{48, 68, -20}, {69, 69, 178}, {70, 122, -36}, },
            {{48, 90, -12}, {95, 95, 179}, {97, 122, 31}, },
            {{48, 77, -14}, {78, 78, 180}, {79, 122, -15}, },
            {{48, 90, -12}, {95, 95, 181}, {97, 122, 31}, },
            {{48, 82, -22}, {83, 83, 182}, {84, 122, -11}, },
            {{48, 77, -14}, {78, 78, 183}, {79, 122, -15}, },
            {{48, 83, -37}, {84, 84, 184}, {85, 122, -37}, },
            {{48, 122, -12}, },
            {{48, 82, -22}, {83, 83, 185}, {84, 89, 27}, {90, 90, 186}, {95, 122, -11}, },
            {{48, 83, -37}, {84, 84, 187}, {85, 122, -37}, },
            {{48, 68, -20}, {69, 69, 188}, {70, 122, -36}, },
            {{48, 77, -14}, {78, 78, 189}, {79, 122, -15}, },
            {{48, 122, -12}, },
            {{48, 68, -20}, {69, 69, 190}, {70, 122, -36}, },
            {{48, 77, -14}, {78, 78, 191}, {79, 122, -15}, },
            {{48, 66, -39}, {67, 67, 192}, {68, 122, -40}, },
            {{48, 82, -22}, {83, 83, 193}, {84, 122, -11}, },
            {{48, 66, -39}, {67, 67, 194}, {68, 85, 27}, {86, 86, 195}, {87, 122, -39}, },
            {{48, 82, -22}, {83, 83, 196}, {84, 122, -11}, },
            {{48, 66, -39}, {67, 67, 197}, {68, 85, 27}, {86, 86, 198}, {87, 122, -39}, },
            {{48, 122, -12}, },
            {{48, 83, -37}, {84, 84, 199}, {85, 122, -37}, },
            {{48, 57, 26}, {65, 65, 200}, {66, 122, -23}, },
            {{48, 57, 26}, {65, 65, 201}, {66, 122, -23}, },
            {{48, 57, 26}, {65, 65, 202}, {66, 122, -23}, },
            {{48, 122, -12}, },
            {{48, 81, -19}, {82, 82, 203}, {83, 122, -19}, },
            {{48, 82, -22}, {83, 83, 204}, {84, 122, -11}, },
            {{48, 82, -22}, {83, 83, 205}, {84, 122, -11}, },
            {{48, 83, -37}, {84, 84, 206}, {85, 122, -37}, },
            {{48, 71, -64}, {72, 72, 207}, {73, 122, -64}, },
            {{48, 122, -12}, },
            {{48, 78, -13}, {79, 79, 208}, {80, 122, -13}, },
            {{48, 57, 26}, {65, 65, 209}, {66, 122, -23}, },
            {{48, 122, -12}, },
            {{48, 78, -13}, {79, 79, 210}, {80, 122, -13}, },
            {{48, 57, 26}, {65, 65, 211}, {66, 122, -23}, },
            {{48, 82, -22}, {83, 83, 212}, {84, 122, -11}, },
            {{48, 83, -37}, {84, 84, 213}, {85, 122, -37}, },
            {{48, 83, -37}, {84, 84, 214}, {85, 122, -37}, },
            {{48, 83, -37}, {84, 84, 215}, {85, 122, -37}, },
            {{48, 57, 26}, {65, 65, 216}, {66, 122, -23}, },
            {{48, 122, -12}, },
            {{48, 122, -12}, },
            {{48, 122, -12}, },
            {{48, 72, -68}, {73, 73, 217}, {74, 122, -68}, },
            {{48, 77, -14}, {78, 78, 218}, {79, 122, -15}, },
            {{48, 81, -19}, {82, 82, 219}, {83, 122, -19}, },
            {{48, 77, -14}, {78, 78, 220}, {79, 122, -15}, },
            {{48, 81, -19}, {82, 82, 221}, {83, 122, -19}, },
            {{48, 122, -12}, },
            {{48, 72, -68}, {73, 73, 222}, {74, 122, -68}, },
            {{48, 72, -68}, {73, 73, 223}, {74, 122, -68}, },
            {{48, 72, -68}, {73, 73, 224}, {74, 122, -68}, },
            {{48, 83, -37}, {84, 84, 225}, {85, 122, -37}, },
            {{48, 77, -14}, {78, 78, 226}, {79, 122, -15}, },
            {{48, 82, -22}, {83, 83, 227}, {84, 122, -11}, },
            {{48, 72, -68}, {73, 73, 228}, {74, 122, -68}, },
            {{48, 82, -22}, {83, 83, 229}, {84, 122, -11}, },
            {{48, 72, -68}, {73, 73, 230}, {74, 122, -68}, },
            {{48, 78, -13}, {79, 79, 231}, {80, 122, -13}, },
            {{48, 78, -13}, {79, 79, 232}, {80, 122, -13}, },
            {{48, 78, -13}, {79, 79, 233}, {80, 122, -13}, },
            {{48, 72, -68}, {73, 73, 234}, {74, 122, -68}, },
            {{48, 68, -20}, {69, 69, 235}, {70, 122, -36}, },
            {{48, 83, -37}, {84, 84, 236}, {85, 122, -37}, },
            {{48, 57, 26}, {65, 65, 237}, {66, 122, -23}, },
            {{48, 83, -37}, {84, 84, 238}, {85, 122, -37}, },
            {{48, 57, 26}, {65, 65, 239}, {66, 122, -23}, },
            {{48, 77, -14}, {78, 78, 240}, {79, 122, -15}, },
            {{48, 77, -14}, {78, 78, 241}, {79, 122, -15}, },
            {{48, 77, -14}, {78, 78, 242}, {79, 122, -15}, },
            {{48, 78, -13}, {79, 79, 243}, {80, 122, -13}, },
            {{48, 122, -12}, },
            {{48, 57, 26}, {65, 65, 244}, {66, 122, -23}, },
            {{48, 65, -11}, {66, 66, 245}, {67, 122, -122}, },
            {{48, 57, 26}, {65, 65, 246}, {66, 122, -23}, },
            {{48, 65, -11}, {66, 66, 247}, {67, 122, -122}, },
            {{48, 122, -12}, },
            {{48, 122, -12}, },
            {{48, 122, -12}, },
            {{48, 77, -14}, {78, 78, 248}, {79, 122, -15}, },
            {{48, 77, -14}, {78, 78, 249}, {79, 122, -15}, },
            {{48, 75, -46}, {76, 76, 250}, {77, 122, -46}, },
            {{48, 77, -14}, {78, 78, 251}, {79, 122, -15}, },
            {{48, 75, -46}, {76, 76, 252}, {77, 122, -46}, },
            {{48, 82, -22}, {83, 83, 253}, {84, 122, -11}, },
            {{48, 83, -37}, {84, 84, 254}, {85, 122, -37}, },
            {{48, 68, -20}, {69, 69, 255}, {70, 122, -36}, },
            {{48, 83, -37}, {84, 84, 256}, {85, 122, -37}, },
            {{48, 68, -20}, {69, 69, 257}, {70, 122, -36}, },
            {{48, 122, -12}, },
            {{48, 82, -22}, {83, 83, 258}, {84, 122, -11}, },
            {{48, 82, -22}, {83, 83, 259}, {84, 122, -11}, },
            {{48, 82, -22}, {83, 83, 260}, {84, 122, -11}, },
            {{48, 82, -22}, {83, 83, 261}, {84, 122, -11}, },
            {{48, 122, -12}, },
            {{48, 122, -12}, },
            {{48, 122, -12}, },
            {{48, 122, -12}, },
        }
        { // DEFINITIONS_RHS
            {{0, 32, 1}, {33, 33, 2}, {34, 34, 3}, {35, 39, 2}, {40, 40, 4}, {41, 41, 5}, {42, 46, 2}, {47, 47, 6}, {48, 58, 2}, {59, 59, 7}, {60, 64, 2}, {65, 65, 8}, {66, 66, 9}, {67, 67, 10}, {68, 68, 11}, {69, 69, 12}, {70, 72, 11}, {73, 73, 13}, {74, 75, 11}, {76, 76, 14}, {77, 77, 15}, {78, 78, 11}, {79, 79, 16}, {80, 80, 17}, {81, 81, 11}, {82, 82, 18}, {83, 83, 19}, {84, 84, 11}, {85, 85, 20}, {86, 86, 21}, {87, 87, 22}, {88, 90, 11}, {91, 96, 2}, {97, 122, 23}, {123, 126, 2}, {127, 160, 1}, {161, 8205, 2}, {8206, 8207, 1}, {8208, 8231, 2}, {8232, 8233, 1}, {8234, 65535, 2}, },
            {{0, 32, 1}, {127, 160, 1}, {8206, 8207, 1}, {8232, 8233, 1}, },
            {},
            {{0, 33, 24}, {34, 34, 25}, {35, 91, 24}, {92, 92, 26}, {93, 65535, 24}, },
            {},
            {},
            {{42, 42, 27}, {47, 47, 28}, },
            {},
            {{48, 57, 29}, {65, 65, 30}, {66, 66, 31}, {67, 77, 30}, {78, 78, 32}, {79, 82, 30}, {83, 83, 33}, {84, 90, 30}, {95, 95, 34}, {97, 122, 35}, },
            {{48, 57, 29}, {65, 68, 30}, {69, 69, 36}, {70, 90, 30}, {95, 122, -10}, },
            {{48, 57, 29}, {65, 65, 37}, {66, 71, 30}, {72, 72, 38}, {73, 78, 30}, {79, 79, 39}, {80, 90, 30}, {95, 122, -10}, },
            {{48, 57, 29}, {65, 90, 30}, {95, 122, -10}, },
            {{48, 57, 29}, {65, 77, 30}, {78, 78, 40}, {79, 85, 30}, {86, 86, 41}, {87, 87, 30}, {88, 88, 42}, {89, 90, 30}, {95, 122, -10}, },
            {{48, 57, 29}, {65, 69, 30}, {70, 70, 43}, {71, 76, 30}, {77, 77, 44}, {78, 78, 45}, {79, 90, 30}, {95, 122, -10}, },
            {{48, 68, -11}, {69, 69, 46}, {70, 78, 30}, {79, 79, 47}, {80, 122, -12}, },
            {{48, 57, 29}, {65, 65, 48}, {66, 78, 30}, {79, 79, 49}, {80, 122, -12}, },
            {{48, 57, 29}, {65, 79, 30}, {80, 80, 50}, {81, 90, 30}, {95, 122, -10}, },
            {{48, 57, 29}, {65, 81, 30}, {82, 82, 51}, {83, 90, 30}, {95, 122, -10}, },
            {{48, 68, -11}, {69, 69, 52}, {70, 84, 30}, {85, 85, 53}, {86, 90, 30}, {95, 122, -10}, },
            {{48, 68, -11}, {69, 69, 54}, {70, 88, 30}, {89, 89, 55}, {90, 90, 30}, {95, 122, -10}, },
            {{48, 57, 29}, {65, 82, 30}, {83, 83, 56}, {84, 122, -10}, },
            {{48, 57, 29}, {65, 65, 57}, {66, 90, 30}, {95, 122, -10}, },
            {{48, 57, 29}, {65, 71, 30}, {72, 72, 58}, {73, 90, 30}, {95, 122, -10}, },
            {{48, 122, -13}, },
            {{0, 65535, -5}, },
            {},
            {{0, 33, 24}, {34, 34, 59}, {35, 65535, -5}, },
            {},
            {{0, 9, 60}, {10, 10, 61}, {11, 12, 60}, {13, 13, 61}, {14, 65535, 60}, },
            {{48, 122, -13}, },
            {{48, 122, -13}, },
            {{48, 82, -22}, {83, 83, 62}, {84, 122, -10}, },
            {{48, 57, 29}, {65, 88, 30}, {89, 89, 63}, {90, 122, -21}, },
            {{48, 82, -22}, {83, 83, 64}, {84, 122, -10}, },
            {{48, 122, -13}, },
            {{48, 122, -13}, },
            {{48, 57, 29}, {65, 70, 30}, {71, 71, 65}, {72, 90, 30}, {95, 122, -10}, },
            {{48, 82, -22}, {83, 83, 66}, {84, 122, -10}, },
            {{48, 57, 29}, {65, 78, 30}, {79, 79, 67}, {80, 122, -12}, },
            {{48, 77, -14}, {78, 78, 68}, {79, 122, -15}, },
            {{48, 57, 29}, {65, 67, 30}, {68, 68, 69}, {69, 90, 30}, {95, 122, -10}, },
            {{48, 68, -11}, {69, 69, 70}, {70, 122, -11}, },
            {{48, 57, 29}, {65, 83, 30}, {84, 84, 71}, {85, 90, 30}, {95, 122, -10}, },
            {{48, 122, -13}, },
            {{48, 79, -18}, {80, 80, 72}, {81, 122, -18}, },
            {{48, 57, 29}, {65, 66, 30}, {67, 67, 73}, {68, 72, 30}, {73, 73, 74}, {74, 85, 30}, {86, 86, 75}, {87, 90, 30}, {95, 122, -10}, },
            {{48, 83, -44}, {84, 84, 76}, {85, 122, -44}, },
            {{48, 66, -47}, {67, 67, 77}, {68, 90, 30}, {95, 122, -10}, },
            {{48, 66, -47}, {67, 67, 78}, {68, 122, -49}, },
            {{48, 67, -42}, {68, 68, 79}, {69, 122, -42}, },
            {{48, 68, -11}, {69, 69, 80}, {70, 122, -11}, },
            {{48, 68, -11}, {69, 69, 81}, {70, 78, 30}, {79, 79, 82}, {80, 122, -12}, },
            {{48, 69, -15}, {70, 70, 83}, {71, 90, 30}, {95, 122, -10}, },
            {{48, 57, 29}, {65, 75, 30}, {76, 76, 84}, {77, 90, 30}, {95, 122, -10}, },
            {{48, 68, -11}, {69, 69, 85}, {70, 75, 30}, {76, 76, 86}, {77, 83, 30}, {84, 84, 87}, {85, 122, -44}, },
            {{48, 82, -22}, {83, 83, 88}, {84, 122, -10}, },
            {{48, 68, -11}, {69, 69, 89}, {70, 122, -11}, },
            {{48, 75, -55}, {76, 76, 90}, {77, 81, 30}, {82, 82, 91}, {83, 122, -19}, },
            {{48, 57, 29}, {65, 72, 30}, {73, 73, 92}, {74, 90, 30}, {95, 122, -10}, },
            {{0, 65535, -5}, },
            {{0, 65535, -30}, },
            {},
            {{48, 83, -44}, {84, 84, 93}, {85, 122, -44}, },
            {{48, 122, -13}, },
            {{48, 68, -11}, {69, 69, 94}, {70, 122, -11}, },
            {{48, 72, -60}, {73, 73, 95}, {74, 122, -60}, },
            {{48, 68, -11}, {69, 69, 96}, {70, 122, -11}, },
            {{48, 72, -60}, {73, 73, 97}, {74, 122, -60}, },
            {{48, 66, -47}, {67, 67, 98}, {68, 82, 30}, {83, 83, 99}, {84, 122, -10}, },
            {{48, 122, -13}, },
            {{48, 77, -14}, {78, 78, 100}, {79, 122, -15}, },
            {{48, 68, -11}, {69, 69, 101}, {70, 122, -11}, },
            {{48, 75, -55}, {76, 76, 102}, {77, 78, 30}, {79, 79, 103}, {80, 122, -12}, },
            {{48, 75, -55}, {76, 76, 104}, {77, 122, -55}, },
            {{48, 83, -44}, {84, 84, 105}, {85, 122, -44}, },
            {{48, 57, 29}, {65, 65, 106}, {66, 122, -23}, },
            {{48, 122, -13}, },
            {{48, 57, 29}, {65, 65, 107}, {66, 122, -23}, },
            {{48, 71, -24}, {72, 72, 108}, {73, 122, -24}, },
            {{48, 68, -11}, {69, 69, 109}, {70, 122, -11}, },
            {{48, 81, -19}, {82, 82, 110}, {83, 122, -19}, },
            {{48, 122, -13}, },
            {{48, 57, 29}, {65, 76, 30}, {77, 77, 111}, {78, 79, 30}, {80, 80, 112}, {81, 122, -18}, },
            {{48, 72, -60}, {73, 73, 113}, {74, 122, -60}, },
            {{48, 68, -11}, {69, 69, 114}, {70, 122, -11}, },
            {{48, 82, -22}, {83, 83, 115}, {84, 122, -10}, },
            {{48, 68, -11}, {69, 69, 116}, {70, 122, -11}, },
            {{48, 82, -22}, {83, 83, 117}, {84, 122, -10}, },
            {{48, 83, -44}, {84, 84, 118}, {85, 122, -44}, },
            {{48, 82, -22}, {83, 83, 119}, {84, 122, -10}, },
            {{48, 57, 29}, {65, 84, 30}, {85, 85, 120}, {86, 122, -20}, },
            {{48, 72, -60}, {73, 73, 121}, {74, 122, -60}, },
            {{48, 75, -55}, {76, 76, 122}, {77, 122, -55}, },
            {{48, 81, -19}, {82, 82, 123}, {83, 122, -19}, },
            {{48, 81, -19}, {82, 82, 124}, {83, 122, -19}, },
            {{48, 77, -14}, {78, 78, 125}, {79, 122, -15}, },
            {{48, 122, -13}, },
            {{48, 66, -47}, {67, 67, 126}, {68, 122, -49}, },
            {{48, 81, -19}, {82, 82, 127}, {83, 122, -19}, },
            {{48, 83, -44}, {84, 84, 128}, {85, 122, -44}, },
            {{48, 83, -44}, {84, 84, 129}, {85, 122, -44}, },
            {{48, 77, -14}, {78, 78, 130}, {79, 122, -15}, },
            {{48, 68, -11}, {69, 69, 131}, {70, 122, -11}, },
            {{48, 81, -19}, {82, 82, 132}, {83, 122, -19}, },
            {{48, 84, -92}, {85, 85, 133}, {86, 122, -20}, },
            {{48, 72, -60}, {73, 73, 134}, {74, 122, -60}, },
            {{48, 81, -19}, {82, 82, 135}, {83, 122, -19}, },
            {{48, 75, -55}, {76, 76, 136}, {77, 122, -55}, },
            {{48, 72, -60}, {73, 73, 137}, {74, 122, -60}, },
            {{48, 75, -55}, {76, 76, 138}, {77, 122, -55}, },
            {{48, 57, 29}, {65, 65, 139}, {66, 122, -23}, },
            {{48, 78, -40}, {79, 79, 140}, {80, 122, -12}, },
            {{48, 68, -11}, {69, 69, 141}, {70, 122, -11}, },
            {{48, 77, -14}, {78, 78, 142}, {79, 122, -15}, },
            {{48, 82, -22}, {83, 83, 143}, {84, 122, -10}, },
            {{48, 122, -13}, },
            {{48, 66, -47}, {67, 67, 144}, {68, 122, -49}, },
            {{48, 122, -13}, },
            {{48, 68, -11}, {69, 69, 145}, {70, 122, -11}, },
            {{48, 122, -13}, },
            {{48, 68, -11}, {69, 69, 146}, {70, 122, -11}, },
            {{48, 57, 29}, {65, 65, 147}, {66, 122, -23}, },
            {{48, 68, -11}, {69, 69, 148}, {70, 122, -11}, },
            {{48, 57, 29}, {65, 65, 149}, {66, 122, -23}, },
            {{48, 83, -44}, {84, 84, 150}, {85, 122, -44}, },
            {{48, 122, -13}, },
            {{48, 68, -11}, {69, 69, 151}, {70, 122, -11}, },
            {{48, 68, -11}, {69, 69, 152}, {70, 122, -11}, },
            {{48, 57, 29}, {65, 65, 153}, {66, 81, 30}, {82, 82, 154}, {83, 122, -19}, },
            {{48, 82, -22}, {83, 83, 155}, {84, 122, -10}, },
            {{48, 67, -42}, {68, 68, 156}, {69, 122, -42}, },
            {{48, 76, -84}, {77, 77, 157}, {78, 90, 30}, {95, 122, -10}, },
            {{48, 83, -44}, {84, 84, 158}, {85, 122, -44}, },
            {{48, 67, -42}, {68, 68, 159}, {69, 122, -42}, },
            {{48, 57, 29}, {65, 65, 160}, {66, 122, -23}, },
            {{48, 72, -60}, {73, 73, 161}, {74, 122, -60}, },
            {{48, 90, -13}, {95, 95, 162}, {97, 122, 35}, },
            {{48, 77, -14}, {78, 78, 163}, {79, 122, -15}, },
            {{48, 122, -13}, },
            {{48, 83, -44}, {84, 84, 164}, {85, 122, -44}, },
            {{48, 83, -44}, {84, 84, 165}, {85, 122, -44}, },
            {{48, 81, -19}, {82, 82, 166}, {83, 122, -19}, },
            {{48, 68, -11}, {69, 69, 167}, {70, 122, -11}, },
            {{48, 90, -13}, {95, 95, 168}, {97, 122, 35}, },
            {{48, 83, -44}, {84, 84, 169}, {85, 122, -44}, },
            {{48, 76, -84}, {77, 77, 170}, {78, 122, -133}, },
            {{48, 82, -22}, {83, 83, 171}, {84, 122, -10}, },
            {{48, 65, -10}, {66, 66, 172}, {67, 90, 30}, {95, 122, -10}, },
            {{48, 122, -13}, },
            {{48, 66, -47}, {67, 67, 173}, {68, 122, -49}, },
            {{48, 72, -60}, {73, 73, 174}, {74, 122, -60}, },
            {{48, 122, -13}, },
            {{48, 83, -44}, {84, 84, 175}, {85, 122, -44}, },
            {{48, 77, -14}, {78, 78, 176}, {79, 122, -15}, },
            {{48, 57, 29}, {65, 65, 177}, {66, 122, -23}, },
            {{48, 122, -13}, },
            {{48, 82, -22}, {83, 83, 178}, {84, 122, -10}, },
            {{48, 68, -11}, {69, 69, 179}, {70, 122, -11}, },
            {{48, 82, -22}, {83, 83, 180}, {84, 122, -10}, },
            {{48, 68, -11}, {69, 69, 181}, {70, 122, -11}, },
            {{48, 75, -55}, {76, 76, 182}, {77, 122, -55}, },
            {{48, 57, 29}, {65, 65, 183}, {66, 122, -23}, },
            {{48, 78, -40}, {79, 79, 184}, {80, 122, -12}, },
            {{48, 68, -11}, {69, 69, 185}, {70, 122, -11}, },
            {{48, 72, -60}, {73, 73, 186}, {74, 122, -60}, },
            {{48, 68, -11}, {69, 69, 187}, {70, 122, -11}, },
            {{48, 83, -44}, {84, 84, 188}, {85, 122, -44}, },
            {{48, 76, -84}, {77, 77, 189}, {78, 82, 30}, {83, 83, 190}, {84, 122, -10}, },
            {{48, 76, -84}, {77, 77, 191}, {78, 122, -133}, },
            {{48, 122, -13}, },
            {{48, 122, -13}, },
            {{48, 122, -13}, },
            {{48, 75, -55}, {76, 76, 192}, {77, 122, -55}, },
            {{48, 83, -44}, {84, 84, 193}, {85, 122, -44}, },
            {{48, 78, -40}, {79, 79, 194}, {80, 122, -12}, },
            {{48, 68, -11}, {69, 69, 195}, {70, 122, -11}, },
            {{48, 83, -44}, {84, 84, 196}, {85, 122, -44}, },
            {{48, 72, -60}, {73, 73, 197}, {74, 122, -60}, },
            {{48, 122, -13}, },
            {{48, 77, -14}, {78, 78, 198}, {79, 122, -15}, },
            {{48, 122, -13}, },
            {{48, 82, -22}, {83, 83, 199}, {84, 122, -10}, },
            {{48, 72, -60}, {73, 73, 200}, {74, 122, -60}, },
            {{48, 77, -14}, {78, 78, 201}, {79, 122, -15}, },
            {{48, 79, -18}, {80, 80, 202}, {81, 122, -18}, },
            {{48, 122, -13}, },
            {{48, 78, -40}, {79, 79, 203}, {80, 122, -12}, },
            {{48, 82, -22}, {83, 83, 204}, {84, 122, -10}, },
            {{48, 72, -60}, {73, 73, 205}, {74, 122, -60}, },
            {{48, 68, -11}, {69, 69, 206}, {70, 122, -11}, },
            {{48, 122, -13}, },
            {{48, 57, 29}, {65, 65, 207}, {66, 122, -23}, },
            {{48, 68, -11}, {69, 69, 208}, {70, 122, -11}, },
            {{48, 90, -13}, {95, 95, 209}, {97, 122, 35}, },
            {{48, 77, -14}, {78, 78, 210}, {79, 122, -15}, },
            {{48, 90, -13}, {95, 95, 211}, {97, 122, 35}, },
            {{48, 82, -22}, {83, 83, 212}, {84, 122, -10}, },
            {{48, 77, -14}, {78, 78, 213}, {79, 122, -15}, },
            {{48, 83, -44}, {84, 84, 214}, {85, 122, -44}, },
            {{48, 122, -13}, },
            {{48, 82, -22}, {83, 83, 215}, {84, 89, 30}, {90, 90, 216}, {95, 122, -10}, },
            {{48, 83, -44}, {84, 84, 217}, {85, 122, -44}, },
            {{48, 68, -11}, {69, 69, 218}, {70, 122, -11}, },
            {{48, 77, -14}, {78, 78, 219}, {79, 122, -15}, },
            {{48, 122, -13}, },
            {{48, 68, -11}, {69, 69, 220}, {70, 122, -11}, },
            {{48, 77, -14}, {78, 78, 221}, {79, 122, -15}, },
            {{48, 66, -47}, {67, 67, 222}, {68, 122, -49}, },
            {{48, 82, -22}, {83, 83, 223}, {84, 122, -10}, },
            {{48, 66, -47}, {67, 67, 224}, {68, 85, 30}, {86, 86, 225}, {87, 122, -47}, },
            {{48, 82, -22}, {83, 83, 226}, {84, 122, -10}, },
            {{48, 66, -47}, {67, 67, 227}, {68, 85, 30}, {86, 86, 228}, {87, 122, -47}, },
            {{48, 122, -13}, },
            {{48, 83, -44}, {84, 84, 229}, {85, 122, -44}, },
            {{48, 57, 29}, {65, 65, 230}, {66, 122, -23}, },
            {{48, 57, 29}, {65, 65, 231}, {66, 122, -23}, },
            {{48, 57, 29}, {65, 65, 232}, {66, 122, -23}, },
            {{48, 122, -13}, },
            {{48, 81, -19}, {82, 82, 233}, {83, 122, -19}, },
            {{48, 82, -22}, {83, 83, 234}, {84, 122, -10}, },
            {{48, 82, -22}, {83, 83, 235}, {84, 122, -10}, },
            {{48, 83, -44}, {84, 84, 236}, {85, 122, -44}, },
            {{48, 71, -24}, {72, 72, 237}, {73, 122, -24}, },
            {{48, 122, -13}, },
            {{48, 78, -40}, {79, 79, 238}, {80, 122, -12}, },
            {{48, 57, 29}, {65, 65, 239}, {66, 122, -23}, },
            {{48, 122, -13}, },
            {{48, 78, -40}, {79, 79, 240}, {80, 122, -12}, },
            {{48, 57, 29}, {65, 65, 241}, {66, 122, -23}, },
            {{48, 82, -22}, {83, 83, 242}, {84, 122, -10}, },
            {{48, 83, -44}, {84, 84, 243}, {85, 122, -44}, },
            {{48, 83, -44}, {84, 84, 244}, {85, 122, -44}, },
            {{48, 83, -44}, {84, 84, 245}, {85, 122, -44}, },
            {{48, 57, 29}, {65, 65, 246}, {66, 122, -23}, },
            {{48, 122, -13}, },
            {{48, 122, -13}, },
            {{48, 122, -13}, },
            {{48, 72, -60}, {73, 73, 247}, {74, 122, -60}, },
            {{48, 77, -14}, {78, 78, 248}, {79, 122, -15}, },
            {{48, 81, -19}, {82, 82, 249}, {83, 122, -19}, },
            {{48, 77, -14}, {78, 78, 250}, {79, 122, -15}, },
            {{48, 81, -19}, {82, 82, 251}, {83, 122, -19}, },
            {{48, 122, -13}, },
            {{48, 72, -60}, {73, 73, 252}, {74, 122, -60}, },
            {{48, 72, -60}, {73, 73, 253}, {74, 122, -60}, },
            {{48, 72, -60}, {73, 73, 254}, {74, 122, -60}, },
            {{48, 83, -44}, {84, 84, 255}, {85, 122, -44}, },
            {{48, 77, -14}, {78, 78, 256}, {79, 122, -15}, },
            {{48, 82, -22}, {83, 83, 257}, {84, 122, -10}, },
            {{48, 72, -60}, {73, 73, 258}, {74, 122, -60}, },
            {{48, 82, -22}, {83, 83, 259}, {84, 122, -10}, },
            {{48, 72, -60}, {73, 73, 260}, {74, 122, -60}, },
            {{48, 78, -40}, {79, 79, 261}, {80, 122, -12}, },
            {{48, 78, -40}, {79, 79, 262}, {80, 122, -12}, },
            {{48, 78, -40}, {79, 79, 263}, {80, 122, -12}, },
            {{48, 72, -60}, {73, 73, 264}, {74, 122, -60}, },
            {{48, 68, -11}, {69, 69, 265}, {70, 122, -11}, },
            {{48, 83, -44}, {84, 84, 266}, {85, 122, -44}, },
            {{48, 57, 29}, {65, 65, 267}, {66, 122, -23}, },
            {{48, 83, -44}, {84, 84, 268}, {85, 122, -44}, },
            {{48, 57, 29}, {65, 65, 269}, {66, 122, -23}, },
            {{48, 77, -14}, {78, 78, 270}, {79, 122, -15}, },
            {{48, 77, -14}, {78, 78, 271}, {79, 122, -15}, },
            {{48, 77, -14}, {78, 78, 272}, {79, 122, -15}, },
            {{48, 78, -40}, {79, 79, 273}, {80, 122, -12}, },
            {{48, 122, -13}, },
            {{48, 57, 29}, {65, 65, 274}, {66, 122, -23}, },
            {{48, 65, -10}, {66, 66, 275}, {67, 122, -149}, },
            {{48, 57, 29}, {65, 65, 276}, {66, 122, -23}, },
            {{48, 65, -10}, {66, 66, 277}, {67, 122, -149}, },
            {{48, 122, -13}, },
            {{48, 122, -13}, },
            {{48, 122, -13}, },
            {{48, 77, -14}, {78, 78, 278}, {79, 122, -15}, },
            {{48, 77, -14}, {78, 78, 279}, {79, 122, -15}, },
            {{48, 75, -55}, {76, 76, 280}, {77, 122, -55}, },
            {{48, 77, -14}, {78, 78, 281}, {79, 122, -15}, },
            {{48, 75, -55}, {76, 76, 282}, {77, 122, -55}, },
            {{48, 82, -22}, {83, 83, 283}, {84, 122, -10}, },
            {{48, 83, -44}, {84, 84, 284}, {85, 122, -44}, },
            {{48, 68, -11}, {69, 69, 285}, {70, 122, -11}, },
            {{48, 83, -44}, {84, 84, 286}, {85, 122, -44}, },
            {{48, 68, -11}, {69, 69, 287}, {70, 122, -11}, },
            {{48, 122, -13}, },
            {{48, 82, -22}, {83, 83, 288}, {84, 122, -10}, },
            {{48, 82, -22}, {83, 83, 289}, {84, 122, -10}, },
            {{48, 82, -22}, {83, 83, 290}, {84, 122, -10}, },
            {{48, 82, -22}, {83, 83, 291}, {84, 122, -10}, },
            {{48, 122, -13}, },
            {{48, 122, -13}, },
            {{48, 122, -13}, },
            {{48, 122, -13}, },
        }
        { // DEFINITION_FILE
            {{0, 32, 1}, {33, 33, 2}, {34, 34, 3}, {35, 126, 2}, {127, 160, 1}, {161, 8205, 2}, {8206, 8207, 1}, {8208, 8231, 2}, {8232, 8233, 1}, {8234, 65535, 2}, },
            {{0, 33, -2}, {35, 65535, -2}, },
            {{0, 33, 2}, {35, 65535, 2}, },
            {},
        }
        { // NO_DEFINITIONS
            {{0, 32, 1}, {33, 126, 2}, {127, 160, 1}, {161, 8205, 2}, {8206, 8207, 1}, {8208, 8231, 2}, {8232, 8233, 1}, {8234, 65535, 2}, },
            {{0, 65535, -2}, },
            {{0, 65535, 2}, },
        }
        { // COMMENT
            {{0, 32, 1}, {33, 41, 2}, {42, 42, 3}, {43, 126, 2}, {127, 160, 1}, {161, 8205, 2}, {8206, 8207, 1}, {8208, 8231, 2}, {8232, 8233, 1}, {8234, 65535, 2}, },
            {{0, 32, 4}, {127, 160, 4}, {8206, 8207, 4}, {8232, 8233, 4}, },
            {},
            {{47, 47, 5}, },
            {{0, 8233, -3}, },
            {},
        }
    };*/

    private static int[][] accept;
/*  {
        // NORMAL
        {-1, 23, 23, -1, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 24, -1, 23, -1, -1, -1, -1, -1, 0, 3, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, -1, -1, -1, -1, 3, 3, 23, 23, 23, 23, 6, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, -1, -1, -1, -1, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 5, 5, 23, 5, 23, 23, -1, -1, -1, -1, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 5, 23, 23, 23, 23, 23, 23, 23, 23, -1, -1, -1, -1, 23, 23, 23, 23, 23, 23, 5, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 5, 5, 23, -1, -1, -1, -1, 23, 23, 23, 23, 23, 23, 5, 23, 5, 23, 23, 23, 23, 5, 23, 23, 23, 23, 5, 23, 23, -1, -1, -1, -1, 23, 23, 23, 23, 23, 23, 23, 5, 23, 23, 23, 23, 5, 23, 23, 23, 23, -1, -1, -1, -1, 23, 23, 23, 5, 23, 23, 23, 23, 23, 5, 23, 23, 23, 23, 23, 5, -1, -1, 8, -1, 23, 23, 5, 23, 23, 23, 23, 23, 23, 23, 23, 5, 5, 5, 23, -1, 8, -1, 23, 23, 23, 23, 5, 4, 23, 23, 23, 23, 23, 7, -1, 23, 23, 23, 23, 23, 23, 23, 23, 23, 8, 23, 23, 23, 23, 23, 23, 23, 23, 5, 23, 23, 23, 23, 5, 5, 5, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 5, 23, 23, 23, 23, 5, 5, 5, 5, },
        // DEFINITIONS
        {-1, 24, 21, 11, 12, 14, 13, 20, -1, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 0, 3, 15, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 3, 3, 10, 10, 10, 6, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 5, 5, 10, 5, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 5, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 5, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 5, 5, 10, 10, 10, 10, 10, 10, 5, 10, 5, 10, 10, 10, 10, 5, 10, 10, 10, 10, 5, 10, 10, 10, 10, 10, 10, 10, 10, 5, 10, 10, 10, 10, 5, 10, 10, 10, 10, 10, 10, 10, 5, 10, 10, 10, 10, 5, 10, 10, 10, 10, 10, 5, 10, 10, 5, 10, 10, 10, 10, 10, 10, 10, 5, 5, 5, 10, 10, 10, 10, 10, 5, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 5, 10, 10, 10, 10, 5, 5, 5, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 5, 10, 10, 10, 10, 5, 5, 5, 5, },
        // DEFINITIONS_RHS
        {-1, 24, 16, -1, 11, 12, 13, 20, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, 16, -1, 16, -1, 0, 3, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 17, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 16, 3, 3, 19, 17, 19, 19, 19, 19, 19, 18, 19, 19, 19, 19, 19, 19, 17, 19, 19, 19, 19, 17, 19, 19, 19, 19, 19, 19, 19, 19, 19, 17, 19, 19, 19, 19, 17, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 5, 19, 5, 19, 5, 19, 19, 19, 19, 19, 17, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 5, 19, 19, 19, 19, 19, 19, 19, 19, 19, 17, 19, 17, 17, 19, 19, 19, 5, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 17, 5, 5, 19, 19, 19, 19, 19, 19, 5, 19, 5, 19, 19, 19, 19, 5, 19, 19, 19, 19, 5, 19, 19, 19, 19, 19, 19, 19, 19, 5, 19, 19, 19, 19, 5, 19, 19, 19, 19, 19, 19, 19, 5, 19, 19, 19, 19, 5, 19, 19, 19, 19, 19, 5, 19, 19, 5, 19, 19, 19, 19, 19, 19, 19, 5, 5, 5, 19, 19, 19, 19, 19, 5, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 5, 19, 19, 19, 19, 5, 5, 5, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 5, 19, 19, 19, 19, 5, 5, 5, 5, },
        // DEFINITION_FILE
        {22, 22, 22, 21, },
        // NO_DEFINITIONS
        {9, 9, 9, },
        // COMMENT
        {-1, 2, 2, 2, 24, 1, },

    };*/

    public static class State
    {
        public final static State NORMAL = new State(0);
        public final static State DEFINITIONS = new State(1);
        public final static State DEFINITIONS_RHS = new State(2);
        public final static State DEFINITION_FILE = new State(3);
        public final static State NO_DEFINITIONS = new State(4);
        public final static State COMMENT = new State(5);

        private int id;

        private State(  int id)
        {
            this.id = id;
        }

        public int id()
        {
            return this.id;
        }
    }

    static 
    {
        try
        {
            DataInputStream s = new DataInputStream(
                new BufferedInputStream(
                Lexer.class.getResourceAsStream("lexer.dat")));

            // read gotoTable
            int length = s.readInt();
            gotoTable = new int[length][][][];
            for(int i = 0; i < gotoTable.length; i++)
            {
                length = s.readInt();
                gotoTable[i] = new int[length][][];
                for(int j = 0; j < gotoTable[i].length; j++)
                {
                    length = s.readInt();
                    gotoTable[i][j] = new int[length][3];
                    for(int k = 0; k < gotoTable[i][j].length; k++)
                    {
                        for(int l = 0; l < 3; l++)
                        {
                            gotoTable[i][j][k][l] = s.readInt();
                        }
                    }
                }
            }

            // read accept
            length = s.readInt();
            accept = new int[length][];
            for(int i = 0; i < accept.length; i++)
            {
                length = s.readInt();
                accept[i] = new int[length];
                for(int j = 0; j < accept[i].length; j++)
                {
                    accept[i][j] = s.readInt();
                }
            }

            s.close();
        }
        catch(Exception e)
        {
            throw new RuntimeException("The file \"lexer.dat\" is either missing or corrupted.");
        }
    }
}
